Skip to main content Skip to footer

Drag and Drop Image Files into a FlexGrid Cell in JavaScript

Background

Users can drag image files from File Explorer and drop them into a Wijmo FlexGrid cell. In vanilla JavaScript, this can be handled by adding dragover and drop event listeners to the FlexGrid host element.

The FlexGrid hitTest method identifies the cell under the cursor. If the target cell is in the Image column, the dropped image file can be read with FileReader, stored in the row data as a data URL, displayed with CellMaker.makeImage, and later sent to the server.

Steps to Complete

  1. Install Wijmo JavaScript packages.
  2. Add the grid host element and Save button.
  3. Import Wijmo modules and styles.
  4. Create the FlexGrid data and Image column.
  5. Handle dragover and drop events.
  6. Save the updated grid data to the server.

Getting Started

Install Wijmo JavaScript packages

npm install @mescius/wijmo.grid @mescius/wijmo.grid.cellmaker @mescius/wijmo.styles
  • These packages provide the FlexGrid control, the CellMaker helper, and the Wijmo stylesheet.

 

Add the grid host element and Save button

<!-- index.html -->
<!DOCTYPE html>
<html>
<head>
  <meta charset="UTF-8" />
  <title>Drag and Drop Images into FlexGrid</title>
</head>
<body>
  <p>Drag an image from File Explorer into the Image column.</p>

  <button id="saveGrid" type="button">Save Grid</button>

  <div id="grid"></div>

  <script type="module" src="/src/index.js"></script>
</body>
</html>
  • The div element is the FlexGrid host. The Save button sends the updated row data to the server.

 

Import Wijmo modules and styles

// src/index.js
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';

import { AllowResizing, FlexGrid } from '@mescius/wijmo.grid';
import { CellMaker } from '@mescius/wijmo.grid.cellmaker';
  • FlexGrid creates the grid instance, and CellMaker.makeImage displays image URLs or data URLs inside grid cells.
/* src/styles.css */
body {
  font-family: Arial, sans-serif;
}

.wj-flexgrid {
  height: 500px;
}

.wj-flexgrid .cell-img img {
  max-width: 100%;
  max-height: 64px;
  object-fit: contain;
}
  • These styles give the grid visible height and keep dropped images contained within the cell.

 

Create the FlexGrid data and Image column

const data = getSampleData(50);

const grid = new FlexGrid('#grid', {
  itemsSource: data,
  autoGenerateColumns: false,
  columns: [
    { binding: 'id', header: 'ID' },
    { binding: 'country', header: 'Country' },
    { binding: 'product', header: 'Product' },
    {
      binding: 'image',
      header: 'Image',
      isReadOnly: true,
      width: 140,
      cssClass: 'cell-img',
      cellTemplate: CellMaker.makeImage({
        label: 'image not available'
      })
    },
    { binding: 'downloads', header: 'Downloads' },
    { binding: 'sales', header: 'Sales', format: 'n2' },
    { binding: 'expenses', header: 'Expenses', format: 'n2' }
  ]
});

grid.allowResizing = AllowResizing.Both;
grid.rows.defaultSize = 72;

function getSampleData(count) {
  const countries = 'US,Germany,UK,Japan,Italy,Greece'.split(',');
  const products = 'Phones,Computers,Cameras,Stereos'.split(',');
  const rows = [];

  for (let i = 0; i < count; i++) {
    rows.push({
      id: i,
      country: countries[i % countries.length],
      product: products[i % products.length],
      image: null,
      downloads: Math.round(100 + Math.random() * 10000),
      sales: Math.random() * 10000,
      expenses: Math.random() * 5000
    });
  }

  return rows;
}
  • The image field stores the dropped image value. Since the Image column uses CellMaker.makeImage, the stored data URL is displayed as an image.

 

Handle dragover and drop events

grid.hostElement.addEventListener('dragover', e => {
  const ht = getImageCellHitTest(grid, e);

  e.preventDefault();

  if (!e.dataTransfer || !ht || !hasImageItem(e.dataTransfer)) {
    if (e.dataTransfer) {
      e.dataTransfer.dropEffect = 'none';
    }
    return;
  }

  e.dataTransfer.dropEffect = 'copy';
});

grid.hostElement.addEventListener('drop', e => {
  const ht = getImageCellHitTest(grid, e);

  e.preventDefault();

  if (!e.dataTransfer || !ht) {
    return;
  }

  const file = Array.from(e.dataTransfer.files).find(isImageFile);

  if (!file) {
    return;
  }

  const reader = new FileReader();

  reader.onload = () => {
    grid.setCellData(ht.row, ht.col, reader.result);
  };

  reader.readAsDataURL(file);
});

function getImageCellHitTest(grid, event) {
  const ht = grid.hitTest(event);

  if (ht.panel !== grid.cells || ht.row < 0 || ht.col < 0) {
    return null;
  }

  const column = ht.panel.columns[ht.col];
  return column.binding === 'image' ? ht : null;
}

function hasImageItem(dataTransfer) {
  return Array.from(dataTransfer.items || []).some(item => {
    return item.kind === 'file' && item.type.startsWith('image/');
  });
}

function isImageFile(file) {
  return file.type.startsWith('image/') || /\.(png|gif|bmp|jpe?g|webp)$/i.test(file.name);
}
  • The dragover handler allows dropping only when the target cell is in the Image column and the dragged item is an image. The drop handler reads the image file as a data URL and stores it in the bound grid cell.

 

Save the updated grid data to the server

document.getElementById('saveGrid').addEventListener('click', saveGrid);

async function saveGrid() {
  const response = await fetch('/api/products', {
    method: 'POST',
    headers: {
      'Content-Type': 'application/json'
    },
    body: JSON.stringify(data)
  });

  if (!response.ok) {
    throw new Error('Unable to save grid data.');
  }
}
  • Because the dropped image is stored in each row’s image field, the updated grid data can be sent to the server with the rest of the row values.

 

For large images, consider uploading the original image file separately and storing the returned image URL in the grid instead of storing a Base64 data URL.

Happy coding!

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Drag and Drop Image Files into a FlexGrid Cell in Vue

Background

Wijmo FlexGrid does not include a built-in setting that automatically inserts files dragged from File Explorer into a cell. However, in Vue applications, you can handle the browser’s dragover and drop events on the FlexGrid host element.

The FlexGrid hitTest method identifies the target cell. If the drop target is in the Image column, the dropped image can be read with FileReader, stored in the row data as a data URL, displayed with CellMaker.makeImage, and later sent to the server.

Steps to Complete

  1. Install Wijmo Vue packages.
  2. Register the Wijmo Grid module and import styles.
  3. Create the FlexGrid data and image template.
  4. Initialize the grid and attach drag-and-drop handlers.
  5. Add the FlexGrid markup and Image column.
  6. Save the updated grid data to the server.

Getting Started

Install Wijmo Vue packages

npm install @mescius/wijmo.vue2.grid @mescius/wijmo.grid @mescius/wijmo.grid.cellmaker @mescius/wijmo.styles
  • These packages provide the Vue FlexGrid wrapper, the core grid APIs, the CellMaker helper, and the Wijmo stylesheet.

 

Register the Wijmo Grid module and import styles

// src/main.js
import { createApp } from 'vue';
import { registerGrid } from '@mescius/wijmo.vue2.grid';
import '@mescius/wijmo.styles/wijmo.css';

import App from './App.vue';

const app = createApp(App);

registerGrid(app);

app.mount('#app');
  • registerGrid(app) makes the wj-flex-grid and wj-flex-grid-column components available in Vue templates.
/* src/style.css */
body {
  font-family: Arial, sans-serif;
}

.wj-flexgrid {
  height: 500px;
}

.wj-flexgrid .cell-img img {
  max-width: 100%;
  max-height: 64px;
  object-fit: contain;
}

 

Create the FlexGrid data and image template

<!-- src/App.vue -->
<script setup>
import { ref } from 'vue';
import * as wjGrid from '@mescius/wijmo.grid';
import { CellMaker } from '@mescius/wijmo.grid.cellmaker';

const data = ref(getSampleData(50));

const imageCellTemplate = CellMaker.makeImage({
  label: 'image not available'
});

function getSampleData(count) {
  const countries = 'US,Germany,UK,Japan,Italy,Greece'.split(',');
  const products = 'Phones,Computers,Cameras,Stereos'.split(',');
  const rows = [];

  for (let i = 0; i < count; i++) {
    rows.push({
      id: i,
      country: countries[i % countries.length],
      product: products[i % products.length],
      image: null,
      downloads: Math.round(100 + Math.random() * 10000),
      sales: Math.random() * 10000,
      expenses: Math.random() * 5000
    });
  }

  return rows;
}
</script>
  • The image field stores the dropped image value. CellMaker.makeImage displays the stored data URL as an image in the grid cell.

 

Initialize the grid and attach drag-and-drop handlers

function initGrid(grid) {
  grid.allowResizing = wjGrid.AllowResizing.Both;
  grid.rows.defaultSize = 72;

  const host = grid.hostElement;

  if (host.dataset.imageDropInitialized === 'true') {
    return;
  }

  host.dataset.imageDropInitialized = 'true';

  host.addEventListener('dragover', e => {
    const ht = getImageCellHitTest(grid, e);

    e.preventDefault();

    if (!e.dataTransfer || !ht || !hasImageItem(e.dataTransfer)) {
      if (e.dataTransfer) {
        e.dataTransfer.dropEffect = 'none';
      }
      return;
    }

    e.dataTransfer.dropEffect = 'copy';
  });

  host.addEventListener('drop', e => {
    const ht = getImageCellHitTest(grid, e);

    e.preventDefault();

    if (!e.dataTransfer || !ht) {
      return;
    }

    const file = Array.from(e.dataTransfer.files).find(isImageFile);

    if (!file) {
      return;
    }

    const reader = new FileReader();

    reader.onload = () => {
      grid.setCellData(ht.row, ht.col, reader.result);
    };

    reader.readAsDataURL(file);
  });
}

function getImageCellHitTest(grid, event) {
  const ht = grid.hitTest(event);

  if (ht.panel !== grid.cells || ht.row < 0 || ht.col < 0) {
    return null;
  }

  const column = ht.panel.columns[ht.col];
  return column.binding === 'image' ? ht : null;
}

function hasImageItem(dataTransfer) {
  return Array.from(dataTransfer.items || []).some(item => {
    return item.kind === 'file' && item.type.startsWith('image/');
  });
}

function isImageFile(file) {
  return file.type.startsWith('image/') || /\.(png|gif|bmp|jpe?g|webp)$/i.test(file.name);
}
  • The dragover handler allows dropping only when the user is over the Image column and the dragged item is an image. The drop handler reads the file as a data URL and saves it into the bound grid cell.

 

Add the FlexGrid markup and Image column

<template>
  <p>Drag an image from File Explorer into the Image column.</p>

  <button type="button" @click="saveGrid">
    Save Grid
  </button>

  <wj-flex-grid
    :itemsSource="data"
    :autoGenerateColumns="false"
    :initialized="initGrid"
  >
    <wj-flex-grid-column binding="id" header="ID" />
    <wj-flex-grid-column binding="country" header="Country" />
    <wj-flex-grid-column binding="product" header="Product" />

    <wj-flex-grid-column
      binding="image"
      header="Image"
      :isReadOnly="true"
      :width="140"
      cssClass="cell-img"
      :cellTemplate="imageCellTemplate"
    />

    <wj-flex-grid-column binding="downloads" header="Downloads" />
    <wj-flex-grid-column binding="sales" header="Sales" format="n2" />
    <wj-flex-grid-column binding="expenses" header="Expenses" format="n2" />
  </wj-flex-grid>
</template>
  • The initialized callback provides the FlexGrid instance, where the drag-and-drop event listeners are attached.

 

Save the updated grid data to the server

async function saveGrid() {
  const response = await fetch('/api/products', {
    method: 'POST',
    headers: {
      'Content-Type': 'application/json'
    },
    body: JSON.stringify(data.value)
  });

  if (!response.ok) {
    throw new Error('Unable to save grid data.');
  }
}
  • Because the dropped image is stored in each row’s image field, the updated grid data can be sent to the server with the rest of the row values.

 

For large images, consider uploading the original image file separately and storing the returned image URL in the grid instead of storing a Base64 data URL.

Happy coding!

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Drag and Drop Image Files into a FlexGrid Cell in Angular

Background

Wijmo FlexGrid does not include a built-in setting that automatically inserts files dragged from File Explorer into a cell. However, in Angular applications, you can handle the browser’s dragover and drop events on the FlexGrid host element.

The FlexGrid hitTest method identifies the cell being targeted. If the user drops an image into the Image column, the file can be read with FileReader, stored in the row data as a data URL, displayed with CellMaker.makeImage, and later sent to the server.

Steps to Complete

  1. Install Wijmo Angular packages.
  2. Import Wijmo modules and styles.
  3. Create the FlexGrid data and image template.
  4. Add the FlexGrid markup and Image column.
  5. Handle dragover and drop events.
  6. Save the updated grid data to the server.

Getting Started

Install Wijmo Angular packages

npm install @mescius/wijmo.angular2.grid @mescius/wijmo.grid @mescius/wijmo.grid.cellmaker @mescius/wijmo.styles
  • These packages provide the Angular FlexGrid wrapper, the core grid APIs, the CellMaker helper, and the Wijmo stylesheet.

 

Import Wijmo modules and styles

// src/app.component.ts
import { Component } from '@angular/core';
import { WjGridModule } from '@mescius/wijmo.angular2.grid';
import { AllowResizing, FlexGrid, HitTestInfo } from '@mescius/wijmo.grid';
import { CellMaker } from '@mescius/wijmo.grid.cellmaker';

interface ProductRow {
  id: number;
  country: string;
  product: string;
  image: string | null;
  downloads: number;
  sales: number;
  expenses: number;
}

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [WjGridModule],
  templateUrl: './app.component.html'
})
export class AppComponent {
  // Code from the following steps goes here.
}
/* src/styles.css */
@import '@mescius/wijmo.styles/wijmo.css';

body {
  font-family: Arial, sans-serif;
}

.wj-flexgrid {
  height: 500px;
}

.wj-flexgrid .cell-img img {
  max-width: 100%;
  max-height: 64px;
  object-fit: contain;
}
  • The global stylesheet is used so the styles apply to grid cells generated by Wijmo at runtime.

 

Create the FlexGrid data and image template

data: ProductRow[] = getSampleData(50);

imageCellTemplate = CellMaker.makeImage({
  label: 'image not available'
});

initGrid(grid: FlexGrid): void {
  grid.allowResizing = AllowResizing.Both;
  grid.rows.defaultSize = 72;
}

function getSampleData(count: number): ProductRow[] {
  const countries = 'US,Germany,UK,Japan,Italy,Greece'.split(',');
  const products = 'Phones,Computers,Cameras,Stereos'.split(',');
  const data: ProductRow[] = [];

  for (let i = 0; i < count; i++) {
    data.push({
      id: i,
      country: countries[i % countries.length],
      product: products[i % products.length],
      image: null,
      downloads: Math.round(100 + Math.random() * 10000),
      sales: Math.random() * 10000,
      expenses: Math.random() * 5000
    });
  }

  return data;
}
  • The image field stores the dropped image value. CellMaker.makeImage displays that value as an image in the grid cell.

 

Add the FlexGrid markup and Image column

<!-- src/app.component.html -->
<p>Drag an image from File Explorer into the Image column.</p>

<button type="button" (click)="saveGrid()">Save Grid</button>

<wj-flex-grid
  #flex
  [itemsSource]="data"
  [autoGenerateColumns]="false"
  (initialized)="initGrid(flex)"
  (dragover)="onGridDragOver(flex, $event)"
  (drop)="onGridDrop(flex, $event)"
>
  <wj-flex-grid-column [binding]="'id'" [header]="'ID'"></wj-flex-grid-column>
  <wj-flex-grid-column [binding]="'country'" [header]="'Country'"></wj-flex-grid-column>
  <wj-flex-grid-column [binding]="'product'" [header]="'Product'"></wj-flex-grid-column>

  <wj-flex-grid-column
    [binding]="'image'"
    [header]="'Image'"
    [isReadOnly]="true"
    [width]="140"
    [cssClass]="'cell-img'"
    [cellTemplate]="imageCellTemplate"
  ></wj-flex-grid-column>

  <wj-flex-grid-column [binding]="'downloads'" [header]="'Downloads'"></wj-flex-grid-column>
  <wj-flex-grid-column [binding]="'sales'" [header]="'Sales'" [format]="'n2'"></wj-flex-grid-column>
  <wj-flex-grid-column [binding]="'expenses'" [header]="'Expenses'" [format]="'n2'"></wj-flex-grid-column>
</wj-flex-grid>
  • The grid listens for dragover and drop events. The #flex template variable passes the FlexGrid instance into the Angular event handlers.

 

Handle dragover and drop events

onGridDragOver(grid: FlexGrid, event: DragEvent): void {
  const ht = this.getImageCellHitTest(grid, event);

  event.preventDefault();

  if (!event.dataTransfer || !ht || !this.hasImageItem(event.dataTransfer)) {
    event.dataTransfer?.dropEffect && (event.dataTransfer.dropEffect = 'none');
    return;
  }

  event.dataTransfer.dropEffect = 'copy';
}

onGridDrop(grid: FlexGrid, event: DragEvent): void {
  const ht = this.getImageCellHitTest(grid, event);

  event.preventDefault();

  if (!event.dataTransfer || !ht) {
    return;
  }

  const file = Array.from(event.dataTransfer.files).find(file => this.isImageFile(file));

  if (!file) {
    return;
  }

  const reader = new FileReader();

  reader.onload = () => {
    grid.setCellData(ht.row, ht.col, reader.result as string);
  };

  reader.readAsDataURL(file);
}

private getImageCellHitTest(grid: FlexGrid, event: DragEvent): HitTestInfo | null {
  const ht = grid.hitTest(event);

  if (ht.panel !== grid.cells || ht.row < 0 || ht.col < 0) {
    return null;
  }

  const column = ht.panel.columns[ht.col];
  return column.binding === 'image' ? ht : null;
}

private hasImageItem(dataTransfer: DataTransfer): boolean {
  return Array.from(dataTransfer.items || []).some(item => {
    return item.kind === 'file' && item.type.startsWith('image/');
  });
}

private isImageFile(file: File): boolean {
  return file.type.startsWith('image/') || /\.(png|gif|bmp|jpe?g|webp)$/i.test(file.name);
}
  • The dragover handler allows the drop only when the target cell is in the Image column and the dragged item is an image. The drop handler reads the file as a data URL and stores it in the bound grid cell.

 

Save the updated grid data to the server

async saveGrid(): Promise<void> {
  const response = await fetch('/api/products', {
    method: 'POST',
    headers: {
      'Content-Type': 'application/json'
    },
    body: JSON.stringify(this.data)
  });

  if (!response.ok) {
    throw new Error('Unable to save grid data.');
  }
}
  • Because the dropped image is stored in the row’s image field, the updated grid data can be sent to the server with the rest of the row values.

 

For large images, consider uploading the image file separately and storing the returned image URL in the grid instead of storing a Base64 data URL.

Happy coding!

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Drag and Drop Image Files into a FlexGrid Cell in React

Background

Wijmo FlexGrid does not include a built-in setting that automatically inserts files dragged from File Explorer into a cell. However, in React applications, you can handle the browser’s dragover and drop events on the FlexGrid host element.

By using FlexGrid’s hitTest method, you can determine which cell the user is dragging over, allow drops only in the Image column, read the dropped image with FileReader, and store the result in the grid’s data source. The grid data can then be sent to the server.

Steps to Complete

  1. Install the required Wijmo React packages.
  2. Import the FlexGrid and CellMaker modules.
  3. Create sample data with an image field.
  4. Add helper functions for image drag-and-drop.
  5. Configure the image column and drop behavior.
  6. Add grid styling.

Getting Started

Install the required Wijmo React packages

npm install @mescius/wijmo.react.grid @mescius/wijmo.grid.cellmaker @mescius/wijmo.styles
  • The wijmo.react.grid package provides the React FlexGrid components.
  • The wijmo.grid.cellmaker package provides CellMaker.makeImage, which displays image URLs or data URLs in grid cells.

 

Import the FlexGrid and CellMaker modules

import { useCallback, useMemo, useState } from 'react';
import '@mescius/wijmo.styles/wijmo.css';

import { FlexGrid, FlexGridColumn } from '@mescius/wijmo.react.grid';
import { CellMaker } from '@mescius/wijmo.grid.cellmaker';
import './App.css';
  • These imports allow the FlexGrid and its columns to be declared directly in JSX.
  • The Wijmo CSS file is required for the grid to render correctly.

 

Create sample data with an image field

function getSampleData(count) {
  const countries = 'US,Germany,UK,Japan,Italy,Greece'.split(',');
  const products = 'Phones,Computers,Cameras,Stereos'.split(',');
  const data = [];

  for (let i = 0; i < count; i++) {
    data.push({
      id: i,
      country: countries[i % countries.length],
      product: products[i % products.length],
      image: null,
      downloads: Math.round(100 + Math.random() * 10000),
      sales: Math.random() * 10000,
      expenses: Math.random() * 5000
    });
  }

  return data;
}
  • The image field stores the dropped image as a data URL.
  • Because the value is stored in the row data, it can be included when saving the grid to the server.

 

Add helper functions for image drag-and-drop

function isImageFile(file) {
  return file && (
    file.type.startsWith('image/') ||
    /\.(png|gif|bmp|jpe?g|webp)$/i.test(file.name)
  );
}

function hasImageItem(dataTransfer) {
  const items = dataTransfer?.items;

  if (!items || !items.length) {
    return false;
  }

  return Array.from(items).some(item => {
    return item.kind === 'file' && item.type.startsWith('image/');
  });
}

function getImageCellHitTest(grid, event) {
  const ht = grid.hitTest(event);

  if (ht.panel !== grid.cells || ht.row < 0 || ht.col < 0) {
    return null;
  }

  const column = ht.panel.columns[ht.col];
  return column.binding === 'image' ? ht : null;
}
  • getImageCellHitTest makes sure the user is dropping into a regular grid cell in the image column.
  • isImageFile validates the dropped file before it is read.

 

Configure the image column and drop behavior

export default function App() {
  const [data] = useState(() => getSampleData(50));

  const imageCellTemplate = useMemo(() => {
    return CellMaker.makeImage({
      label: 'image not available'
    });
  }, []);

  const initGrid = useCallback(grid => {
    grid.allowResizing = 'Both';
    grid.rows.defaultSize = 72;

    if (grid.hostElement.dataset.imageDropInitialized === 'true') {
      return;
    }

    grid.hostElement.dataset.imageDropInitialized = 'true';

    grid.hostElement.addEventListener('dragover', e => {
      const ht = getImageCellHitTest(grid, e);

      e.preventDefault();

      if (!ht || !hasImageItem(e.dataTransfer)) {
        e.dataTransfer.dropEffect = 'none';
        return;
      }

      e.dataTransfer.dropEffect = 'copy';
    });

    grid.hostElement.addEventListener('drop', e => {
      const ht = getImageCellHitTest(grid, e);

      e.preventDefault();

      if (!ht) {
        return;
      }

      const file = Array.from(e.dataTransfer.files).find(isImageFile);

      if (!file) {
        return;
      }

      const reader = new FileReader();

      reader.onload = args => {
        grid.setCellData(ht.row, ht.col, args.target.result);
      };

      reader.readAsDataURL(file);
    });
  }, []);

  const saveGrid = useCallback(async () => {
    await fetch('/api/products', {
      method: 'POST',
      headers: {
        'Content-Type': 'application/json'
      },
      body: JSON.stringify(data)
    });
  }, [data]);

  return (
    <>
      <p>Drag an image from File Explorer into the Image column.</p>

      <button type="button" onClick={saveGrid}>
        Save Grid
      </button>

      <FlexGrid
        initialized={initGrid}
        itemsSource={data}
        autoGenerateColumns={false}
      >
        <FlexGridColumn binding="id" header="ID" />
        <FlexGridColumn binding="country" header="Country" />
        <FlexGridColumn binding="product" header="Product" />

        <FlexGridColumn
          binding="image"
          header="Image"
          isReadOnly={true}
          width={140}
          cssClass="cell-img"
          cellTemplate={imageCellTemplate}
        />

        <FlexGridColumn binding="downloads" header="Downloads" />
        <FlexGridColumn binding="sales" header="Sales" format="n2" />
        <FlexGridColumn binding="expenses" header="Expenses" format="n2" />
      </FlexGrid>
    </>
  );
}
  • The dragover event enables dropping only when the target cell is in the Image column and the dragged item is an image.
  • The drop event reads the image file with FileReader.readAsDataURL.
  • grid.setCellData stores the data URL in the bound image field, and CellMaker.makeImage displays it in the cell.
  • The saveGrid function sends the grid’s current data to the server as JSON.

 

Add grid styling

.wj-flexgrid {
  height: 500px;
}

.wj-flexgrid .cell-img img {
  max-width: 100%;
  max-height: 64px;
  object-fit: contain;
}
  • The grid height gives FlexGrid visible space on the page.
  • The image styling keeps dropped images contained within the cell.

 

With this setup, users can drag image files from File Explorer into the Image column, preview the image in the FlexGrid cell, and save the updated grid data to the server.

For larger production images, consider uploading the original image file separately and storing the returned image URL in the grid instead of storing a Base64 data URL.

Happy coding!

Andrew Peterson

Technical Engagement Engineer